/**
 * Created by liuzhengdong on 2018/4/10.
 * file中间件 开发模式用，方便 ajax读取.json .text文件
 * @param {ctx} ctx koa ctx
 */
const fs = require('fs')
const path = require('path')
const currentIP = require('ip').address()
const appConfig = require(path.join(process.cwd(), 'app.config'))
const logger = require('./../logger/koa-logger')('fileMiddle')
module.exports = async function (ctx, next) {
  const proxy = Object.keys(require(path.join(process.cwd(), 'app.config')).proxy) || []
  let indexHTML = ''
  if (proxy.findIndex(val => ctx.url.startsWith(val)) > -1) {
    await next()
  } else {
    const res = ctx.res
    try {
      logger.info('Read File Request Success', `path ----> ${ctx.url}`)
      if (ctx.url.startsWith('/cordova')) {
        context = fs.readFileSync(path.join(process.cwd(), 'dist', ctx.url), 'utf-8')
      } else {
        context = fs.readFileSync(path.join(process.cwd(), ctx.url), 'utf-8')
      }
      res.statusCode = 200
      res.end(context)
    } catch (err) {
      logger.info('Files not found.', `Callback spa index.html ----> ${ctx.url}`)
      // 异常就返回html
      await new Promise((resolve) => {
        if (indexHTML) {
          resolve()
        } else {
          require('http').get('http://' + currentIP + ':' + appConfig.appPort, (response) => {
            response.on('data', (chunk) => {
              logger.info('Fetching index.html succeed.')
              indexHTML = chunk.toString('utf-8')
              resolve()
            })
          }).on('error', (e) => {
            logger.error(`Fetching index.html error: ${e.message}`)
            process.exit(1)
          })
        }
      }).then(doRender)

      function doRender() {
        res.statusCode = 200
        // 这句很重要，否则会影响到weinre调试
        // res.setHeader('Content-Type', 'text/html; charset=utf-8')
        res.end(`${indexHTML}`)
        logger.info('Page routing request')
      }
    }
  }
}
