/**
 * rem响应式方案的实现
 * Created by liuzhengdong on 2018/4/3.
 */
import { throttle } from './StringUtils'
import appConfig from '@cwd/app.config'

const win = global
const doc = win.document
const baseWidth = appConfig.designSize || 750 // 设计稿尺寸
const optimalSize = appConfig.optimalSize || 414 // 最优尺寸
const documentHTML = doc.documentElement

/**
 * 设置html根字体
 */
function setRootFont() {
  const docWidth = documentHTML.getBoundingClientRect().width
  const scale = (docWidth > 720 ? optimalSize : docWidth) / baseWidth
  documentHTML.style.fontSize = `${scale * 100}px`
  documentHTML.setAttribute('data-dpr', global.devicePixelRatio === 3 ? 3 : 2)
}

setRootFont()
win.addEventListener('resize', throttle(setRootFont, 90, 100), false)

