/**
 * 组装vue-loader配置
 * @param {string} env 环境，可能的值prod|dev
 * @return {object} 配置
 * Created by liuzhengdong on 2018/4/3.
 **/

const ExtractCssChunks = require("extract-css-chunks-webpack-plugin")

module.exports = function (env) {
  const config = {
    loader: 'vue-loader',
    options: {
      // 去除模板中的空格
      preserveWhitespace: false,
    },
  }
  // webpack打包时，提取css
  if (env === 'prod') {
    // 生产环境
    config.options.loaders = {
      css: [ExtractCssChunks.loader, 'css-loader'],
      less: [ExtractCssChunks.loader, 'css-loader', 'less-loader'],
    }
  } else {
    // 开发环境
    config.options.loaders = {
      css: ['vue-style-loader', 'css-loader', 'postcss-loader'],
      less: [
        'vue-style-loader', 'css-loader', 'postcss-loader',
        { loader: 'less-loader', options: { sourceMap: false } },
      ],
    }
  }
  return config
}
