/**
 * 开发环境webpack配置
 * Created by liuzhengdong on 2018/4/3.
 */
const webpack = require('webpack')
const path = require('path')
const FriendlyErrorsPlugin = require('friendly-errors-webpack-plugin')
const config = require('./webpack.config.base')('dev')
const appConfig = require(path.join(process.cwd(), 'app.config'))

// cheap-module-source-map is faster for development
config.devtool = '#cheap-module-source-map'

// add hot-reload related code to entry chunks
Object.keys(config.entry).forEach(function (name) {
  config.entry[name] = ['webpack-hot-middleware/client?path=/__webpack_hmr&timeout=2000&reload=true'].concat(config.entry[name])
})
// set mode
config.mode = 'development'

config.module.rules.push(
  {
    test: /\.css$/,
    use: ['vue-style-loader', 'css-loader',
      {
        loader: 'postcss-loader', options: !appConfig.postcssNodeModules ? { exclude: /node_modules/ } : {}
      }],
  },
  {
    test: /\.less$/,
    use: ['vue-style-loader', 'css-loader', 'postcss-loader',
      { loader: 'less-loader', options: { sourceMap: false } },
    ],
  }
)
config.plugins = (config.plugins || []).concat([
  // 全局开启代码热替换
  new webpack.NamedModulesPlugin(),
  new webpack.HotModuleReplacementPlugin(),
  new FriendlyErrorsPlugin(),
])

module.exports = config
