require('shelljs/global')
const fs = require('fs')
const path = require('path')
const sep = path.sep
let exists = fs.existsSync || path.existsSync
let pkgName = require('../package.json').name

// 文件夹选择
let hook = path.resolve(__dirname, 'hook')
let root = exec('git rev-parse --show-toplevel').stdout.replace('\n', '')
let git = path.resolve(root, '.git')
let hooks = path.resolve(git, 'hooks')

let tasks = ['pre-commit', 'commit-msg']

if (!exists(git) || !fs.lstatSync(git).isDirectory()) {
  console.log('请先安装git，再执行 `npm run git-install` 命令安装git钩子')
  process.exit(0)
}

if (!exists(hooks)) {
  console.log('未找到.git/hooks文件夹，帮您创建')
  fs.mkdirSync(hooks)
}

tasks.forEach(value => {
  let task = path.resolve(hooks, value)
  let hookFile = fs.readFileSync(hook).toString()
  hookFile = hookFile.replace('$NODEJS', process.execPath)
  hookFile = hookFile.replace('$NODEJSPATH', path.resolve(process.execPath, '../'))
  hookFile = hookFile.replace('$TASK', `${pkgName}${sep}gitHooks${sep}script${sep}${value}.js`)
  fs.writeFileSync(task, hookFile)

  fs.chmodSync(task, '777')
  console.log(`${task} installed success !`)
})
